// Code generated by "enumer -type=PDFLib -json -text -yaml -sql"; DO NOT EDIT.

//
package pdfLibs

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _PDFLibName = "GOLATEX"

var _PDFLibIndex = [...]uint8{0, 2, 7}

func (i PDFLib) String() string {
	if i < 0 || i >= PDFLib(len(_PDFLibIndex)-1) {
		return fmt.Sprintf("PDFLib(%d)", i)
	}
	return _PDFLibName[_PDFLibIndex[i]:_PDFLibIndex[i+1]]
}

var _PDFLibValues = []PDFLib{0, 1}

var _PDFLibNameToValueMap = map[string]PDFLib{
	_PDFLibName[0:2]: 0,
	_PDFLibName[2:7]: 1,
}

// PDFLibString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func PDFLibString(s string) (PDFLib, error) {
	if val, ok := _PDFLibNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to PDFLib values", s)
}

// PDFLibValues returns all values of the enum
func PDFLibValues() []PDFLib {
	return _PDFLibValues
}

// IsAPDFLib returns "true" if the value is listed in the enum definition. "false" otherwise
func (i PDFLib) IsAPDFLib() bool {
	for _, v := range _PDFLibValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for PDFLib
func (i PDFLib) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for PDFLib
func (i *PDFLib) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("PDFLib should be a string, got %s", data)
	}

	var err error
	*i, err = PDFLibString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for PDFLib
func (i PDFLib) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for PDFLib
func (i *PDFLib) UnmarshalText(text []byte) error {
	var err error
	*i, err = PDFLibString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for PDFLib
func (i PDFLib) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for PDFLib
func (i *PDFLib) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = PDFLibString(s)
	return err
}

func (i PDFLib) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *PDFLib) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := PDFLibString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
